#ifndef MODEL
#define MODEL

#include "./Common.pml"
#include "./Engine.pml"
#include "./Terminal.pml"
#include "./LoadGenerator.pml"
#ifndef OMIT_THEORY
#include "./Theory.prp"
#endif

init
{
  byte y;
  d_step
  {
    printf("Constants:\n");
    printf("event count:\t%d\n", EVENT_COUNT);
    printf("data point count:\t%d\n", SERVICE_COUNT);
    printf("engine count:\t%d\n", ENGINE_COUNT);
    printf("terminal count:\t%d\n", TERMINAL_COUNT);
    for (y : 0 .. ENGINE_COUNT * TERMINAL_COUNT * SERVICE_COUNT - 1)
    {
      messages[y] = MSG_NONE
    }
    /* Input messages will be initialised so that the Load Generator will never
       produce overlapping values. */
    for (y : 0 .. SERVICE_COUNT - 1)
    {
      inputDataPoints[y] = y + 1
    }
  }
  atomic
  {
    for (y : 0 .. ENGINE_COUNT - 1)
    {
      run Engine(y)
    }
    for (y : 0 .. TERMINAL_COUNT - 1)
    {
      run Terminal(y)
    }
    run LoadGenerator()
  }
}

#endif /* MODEL */